### Checkpoint

The project is proceeding mostly according to plan. Here's the highlights:

* Because of some troubles with installation/setup/learning overhead, the API is not as close to completion as it should be. That said, as you can see in the Github repo we have made significant progress in creating a high-level CUDA API. We have multiple flavors of a map primitive (which is the basic underpinning of any CUDA program). Soon we'll have support for managing multiple variables/kernels within a CUDA program instead of a single list. 
* We've benchmarked a basic program and seen some cool performance gains. We ran the following code over an array length 100k

        terra do_work(x : int) : int
           var y : int = 0
           for i = 0, 10000 do
              if i % 3 == 0 or i % 5 == 0 then
                 y = y + 1
              end
           end
           return x + y
        end
    And we found speedups of 7.6x over JIT'd Terra, 14.34x over native C, and within 0.95x of hand-rolled CUDA. And the mapping API is really easy to use, it just looks like:
    
        local kernel = cuda.lua_map(do_work)
        kernel(some_list)
    And `some_list` gets modified in-place. 
* After a lot of blood and tears, we managed to port the serial and CUDA circle renderers to Lua (so we are ahead of schedule in that respect!). We still need to implement the optimizations from asst2 (e.g. quadtree data structure on the circles) and change it to use more of our newly minted API, but that should come quickly in the next few weeks. For the competition, we'll show off the circle renderer and any other examples we may come up with before then. We'll also have graphs comparing speed and code size using our API. 
* At this point, most of the work is just programming and any further API design as our needs develop. We're not facing any serious issues at this point. 