### Goals
The project has three main areas: writing the API, creating programs using the API, and benchmarking the code against other languages/compilers.

We plan to achieve:

* **Writing the API**
    * Allow arbitrary Lua code to be executed in the GPU over a table.
    * Optimize threads/warp usage to the input data.
    * Abstract the API such that the user needs no C libraries and as little Terra as possible.
* **Creating programs**
    * Make a simple saxpy
    * Write matrix operations like transpose or pseudoinverse/SVD
    * Port the Assignment 2 Circle Renderer over to vanilla Lua (using LuaGL)
* **Benchmarking**
    * For each program, benchmark it against equivalent implementations in: vanilla Lua, Terra without CUDA, and C.

We hope to achieve:

* Achieve better performance than vanilla C.
* Implement shared memory in Terra.
* Implement linking against libraries like [cublas](https://developer.nvidia.com/cublas).